package com.crm.rely.backend.util;

import com.crm.rely.backend.core.constant.Constants;

import javax.imageio.ImageIO;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.concurrent.ThreadLocalRandom;

/**
 * 图片验证码工具类
 */
public class ImageVerifyUtil {
    //随机产生数字与字母组合的字符串
//    private static String randString = "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm0123456789";
    private static String randString = "0123456789";
    private static int width = 95;// 图片宽
    private static int height = 25;// 图片高
    private static int lineSize = 40;// 干扰线数量
    private static int stringNum = 6;// 随机产生字符数量
    private static ThreadLocalRandom random = ThreadLocalRandom.current();

    /**
     * 获得字体
     */
    private static Font getFont() {
        return new Font("Fixedsys", Font.CENTER_BASELINE, 18);
    }

    /**
     * 获得颜色
     */
    private static Color getRandColor(int fc, int bc) {

        if (fc > 255) {
            fc = 255;
        }
        if (bc > 255) {
            bc = 255;
        }
        int r = fc + random.nextInt(bc - fc - 16);
        int g = fc + random.nextInt(bc - fc - 14);
        int b = fc + random.nextInt(bc - fc - 18);
        return new Color(r, g, b);
    }

    /**
     * 生成随机图形验证码图片,默认为6位
     *
     * @param request
     * @param response
     */
    public static void getRandCode(HttpServletRequest request, HttpServletResponse response) {
        getRandCode(request, response, stringNum);
    }

    /**
     * 生成随机图形验证码图片
     *
     * @param request
     * @param response
     * @param num      验证码位数
     */
    public static void getRandCode(HttpServletRequest request, HttpServletResponse response, int num) {
        HttpSession session = request.getSession();
        // BufferedImage类是具有缓冲区的Image类,Image类是用于描述图像信息的类
        int width = ImageVerifyUtil.width;
        int lineSize = ImageVerifyUtil.lineSize;
        if (num > 6) {
            width = 13 * (num + 1);
            lineSize = (width / 2) + 15;
        }
        BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_BGR);
        Graphics g = image.getGraphics();// 产生Image对象的Graphics对象,改对象可以在图像上进行各种绘制操作
        g.fillRect(0, 0, width, height);//图片大小
        g.setFont(new Font("Times New Roman", Font.ROMAN_BASELINE, 18));//字体大小
        g.setColor(getRandColor(110, 133));//字体颜色

        // 绘制干扰线
        for (int i = 0; i <= lineSize; i++) {
            drowLine(g, width);
        }
        // 绘制随机字符
        String randomString = "";
        for (int i = 1; i <= num; i++) {
            randomString = drowString(g, randomString, i);
        }
        //将生成的随机字符串保存到session中
        session.removeAttribute(Constants.VALIDATECODE_INFO);
        session.setAttribute(Constants.VALIDATECODE_INFO, randomString);
        //设置失效时间1分钟
        session.setMaxInactiveInterval(60);
        g.dispose();
        try {
            // 将内存中的图片通过流动形式输出到客户端
            ImageIO.write(image, "JPEG", response.getOutputStream());
        } catch (Exception e) {
        }
    }

    /**
     * 验证验证码是否正确 验证码大小写不明感
     *
     * @param request
     * @param code
     * @return
     */
    public static boolean isCode(HttpServletRequest request, String code) {
        HttpSession session = request.getSession();
        String sessionCode = (String) session.getAttribute(Constants.VALIDATECODE_INFO);
        if (!ValidateUtil.vStringNull(sessionCode) || !ValidateUtil.vStringNull(code)) {
            return false;
        }
        if (sessionCode.toLowerCase().equals(code.toLowerCase())) {
            session.removeAttribute(Constants.VALIDATECODE_INFO);
            return true;
        }
        return false;
    }

    /**
     * 绘制字符串
     */
    private static String drowString(Graphics g, String randomString, int i) {

        g.setFont(getFont());
        g.setColor(new Color(random.nextInt(101), random.nextInt(111), random
                .nextInt(121)));
        String rand = GetRandom.getRandom(randString, 1);
        randomString += rand;
//        g.translate(random.nextInt(3), random.nextInt(3));
        g.drawString(rand, 13 * i, 16);
        return randomString;
    }

    /**
     * 绘制干扰线
     *
     * @param g
     * @param width
     */
    private static void drowLine(Graphics g, int width) {

        int x = random.nextInt(width);
        int y = random.nextInt(height);
        int xl = random.nextInt(13);
        int yl = random.nextInt(15);
        g.drawLine(x, y, x + xl, y + yl);
    }
}